package com.zhiqiyun.open.mvc.controller;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.OrderItem;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.zhiqiyun.open.annotation.Permission;
import com.zhiqiyun.open.core.models.category.CategoryMaterial;
import com.zhiqiyun.open.core.models.user.OauthInfo;
import com.zhiqiyun.open.core.service.CategoryMaterialService;
import com.zhiqiyun.open.core.service.OauthService;
import com.zhiqiyun.open.core.service.SequenceService;
import com.zhiqiyun.open.mvc.Result;
import com.zhiqiyun.open.mvc.params.category.QueryCategoryMaterialParam;
import com.zhiqiyun.open.mvc.params.category.SaveCategoryMaterialParam;
import com.zhiqiyun.open.utils.DateUtil;
import com.zhiqiyun.open.utils.ServletContext;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.validation.Valid;
import java.util.List;

@RestController
@RequestMapping("/category/material")
public class CategoryMaterialController {

    @Autowired
    private CategoryMaterialService categoryMaterialService;

    @Autowired
    private SequenceService sequenceService;

    @Autowired
    private OauthService oauthService;

    @Permission(value = "category.material.find", tags = "查询物务资源目录")
    @PostMapping("/findPage")
    public Result findPage(@RequestBody QueryCategoryMaterialParam param) {

        QueryWrapper<CategoryMaterial> wrapper = new QueryWrapper<>();

        if (StringUtils.isNotBlank(param.getName())) {
            wrapper.like("name", param.getName());
        }
        Page<CategoryMaterial> page = param.getPage();
        page.addOrder(OrderItem.asc("sort_number"));
        page.addOrder(OrderItem.desc("id"));

        Page<CategoryMaterial> resultData = this.categoryMaterialService.page(page, wrapper);

        return Result.instance(Result.Code.SUCCESS).setData(resultData);
    }

    @Permission(value = "category.material.add", tags = "新建物务资源目录")
    @PostMapping("/save")
    public Result save(@Valid @RequestBody SaveCategoryMaterialParam param) throws Exception {

        CategoryMaterial entity = new CategoryMaterial();
        BeanUtils.copyProperties(param, entity);

        OauthInfo oauthInfo = this.oauthService.getAuth(ServletContext.getAccessToken());

        if (param.getSortNumber() == null) {
            entity.setSortNumber(0);
        }

        entity.setCreatedTime(DateUtil.current());
        entity.setCreatedBy(oauthInfo.getId());

        entity.setUpdatedTime(DateUtil.current());
        entity.setUpdatedBy(oauthInfo.getId());
        entity.setId(this.sequenceService.nextId());

        this.categoryMaterialService.save(entity);

        return Result.instance(Result.Code.MESSAGE_SUCCESS);
    }

    @Permission(value = "category.material.edit", tags = "更新物务资源目录")
    @PostMapping("/updateById")
    public Result updateById(Long id, @Valid @RequestBody SaveCategoryMaterialParam param) {
        CategoryMaterial entity = new CategoryMaterial();
        BeanUtils.copyProperties(param, entity);

        OauthInfo oauthInfo = this.oauthService.getAuth(ServletContext.getAccessToken());

        if (param.getSortNumber() == null) {
            entity.setSortNumber(0);
        }

        entity.setUpdatedBy(oauthInfo.getId());
        entity.setUpdatedTime(DateUtil.current());
        entity.setId(id);

        this.categoryMaterialService.updateById(entity);

        return Result.instance(Result.Code.MESSAGE_SUCCESS);
    }

    @Permission(value = "category.material.delete", tags = "删除物务资源目录")
    @PostMapping("/deleteByIds")
    public Result deleteByIds(@RequestBody List<Long> ids) {
        this.categoryMaterialService.removeByIds(ids);
        return Result.instance(Result.Code.MESSAGE_SUCCESS);
    }
}
